(function ($) {
    'use strict';



    /**
     * This function generate random string who is used by the plugin.
     * @param length
     * @returns {string}
     * @constructor
     */

    var hs_generate_html_operators = function () {
        var html ;
        for (var option_name in woo_usn_ajax_object.woo_usn_cl_operators_names['woo-usn-operators']) {
            html += "<option class='woo-usn-operators' value='" + option_name + "'>" + woo_usn_ajax_object.woo_usn_cl_operators_names['woo-usn-operators'][option_name] + "</option>";
        }
        return html;
    };

    var hs_hide_show_fields = function ( cl_type_mode ){
        var usn_add_btn = $('input#woousn_add_custom_filters');
        if ( cl_type_mode != "dynamic" ){
            $('tr.woo-usn-customer-list-dynamic').hide();
            $('tr.woo-usn-customer-list-manual').show();
            usn_add_btn.hide();
        }else{
            $('tr.woo-usn-customer-list-dynamic').show();
            $('tr.woo-usn-customer-list-manual').hide();
            usn_add_btn.show();
        }
    }

    var hs_generate_html_math_operators = function () {
        var html ;
        for (var option_name in woo_usn_ajax_object.woo_usn_cl_operators_names['woo-usn-math-operators']) {
            html += "<option class='woo-usn-math-operators' value='" + option_name + "'>" + woo_usn_ajax_object.woo_usn_cl_operators_names['woo-usn-math-operators'][option_name] + "</option>";
        }
        return html;
    };

    var hs_generate_html = function (options) {
        var html ;
        for (var option_name in options) {
            html += "<option class='woo-usn-math-operators' value='" + option_name + "'>" + options[option_name] + "</option>";
        }
        return html;
    };

    var hs_generate_fields = function (hash_code = HSGenerateRandom(5)) {
        var html = "<p data-hash='" + hash_code + "' class='woo-usn-cl-parent'><select class='woo-usn-cl-rules' name='woo-usn[" + hash_code + "][cl-rules]' >";
        for (var option_name in woo_usn_ajax_object.woo_usn_cl_rules_names) {
            html += "<option value='" + option_name + "'>" + woo_usn_ajax_object.woo_usn_cl_rules_names[option_name] + "</option>";
        }
        html += "</select>&nbsp;&nbsp;&nbsp; <select class='woo-usn-cl-options' name='woo-usn[" + hash_code + "][cl-options]'>";
        html += hs_generate_html_operators();
        html += "</select>&nbsp;&nbsp;&nbsp; <span class='woo-usn-cl-values'><select  multiple='multiple' name='woo-usn[" + hash_code + "][cl-values][]'>" + hs_generate_html(woo_usn_ajax_object.woo_usn_get_payment_methods) + "</select></span> <span class='woo-usn-cl-remove-block'><button class='button button-primary woo-usn-cl-remove-block' >Remove</button> </span></p>";
        return html;
    };

    var hs_regenerate_html = function( hashcode, values ){
        $('#woousn-custom-fields-block').append(hs_generate_fields(hashcode));
        $('p[data-hash='+hashcode+'] select.woo-usn-cl-rules').val(values['cl-rules']);
        woo_usn_reset_fields(hashcode, values);
        $('select[name="woo-usn['+hashcode+'][cl-options]"]').val(values['cl-options']);
        $('p[data-hash='+hashcode+'] select[name="woo-usn['+hashcode+'][cl-values][]"]').val(values['cl-values']);
        $('p[data-hash='+hashcode+'] input[name="woo-usn['+hashcode+'][cl-values]"]').val(values['cl-values']);
    };


    var hs_initiate_dynamic_select_fields = function( parent_selector, child_selector ){
        $(child_selector).each(function(index, value){
            if ( index == 0 ){
                var value_name = $(value).val();
                $(parent_selector).select2();
                $(parent_selector).select2('val',value_name);
            }
        });
    }

    /**
     * This function generate the field needed dynamically.
     * 
     * @param string option_name Option fields key.
     * @param string hash_code Option fields value.
     */
    var hs_field_dynamic_views = function (option_name, hash_code) {
        var woo_usn_field_options = $("p[data-hash='" + hash_code + "'] select.woo-usn-cl-options");
        var woo_usn_field_values  = $("p[data-hash='" + hash_code + "'] span.woo-usn-cl-values");
        switch (option_name) {
            //case 'order-products-count':
            case '_order_shipping_tax':
            case '_order_shipping':
            case '_order_tax':
            case '_order_total':
                woo_usn_field_options.empty().append(hs_generate_html_math_operators());
                woo_usn_field_values.empty().attr('name', 'filter-by-amount').append('<input type="number" name="woo-usn[' + hash_code + '][cl-values]"  required/>');
                break;

            case '_payment_method':
                woo_usn_field_options.empty().append(hs_generate_html_operators());
                woo_usn_field_values.empty().attr('name', 'payment-methods').append('<select  multiple="multiple" name="woo-usn[' + hash_code + '][cl-values][]">' + hs_generate_html(woo_usn_ajax_object.woo_usn_get_payment_methods) + '</select>');
                break;

            case '_shipping_method':
                woo_usn_field_options.empty().append(hs_generate_html_operators());
                woo_usn_field_values.empty().attr('name', 'shipping-methods').append('<select multiple="multiple" name="woo-usn[' + hash_code + '][cl-values][]">' + hs_generate_html(woo_usn_ajax_object.woo_usn_get_shipping_methods) + '</select>');
                break;

            case '_billing_country':
            case '_shipping_country':
                woo_usn_field_options.empty().append(hs_generate_html_operators());
                woo_usn_field_values.empty().attr('name', 'filter-by-country').append('<select multiple="multiple" name="woo-usn[' + hash_code + '][cl-values][]">' + hs_generate_html(woo_usn_ajax_object.woo_usn_country) + '</select>');
                break;

            case 'shop_order':
                woo_usn_field_options.empty().append(hs_generate_html_operators());
                woo_usn_field_values.empty().attr('name', 'order-status').append('<select multiple="multiple" name="woo-usn[' + hash_code + '][cl-values][]">' + hs_generate_html(woo_usn_ajax_object.woo_usn_customer_order_status) + '</select>');
                break;

            // case 'customer-roles':
            //     $("p[data-hash='" + hash_code + "'] select.woo-usn-cl-options").empty().append(hs_generate_html_operators());
            //     $("p[data-hash='" + hash_code + "'] span.woo-usn-cl-values").empty().attr('name', 'customer-roles').append('<select multiple="multiple" name="woo-usn[' + hash_code + '][cl-values][]">' + hs_generate_html(woo_usn_ajax_object.woo_usn_customer_roles) + '</select>');
            //     break;

            case '_billing_email':
                woo_usn_field_options.empty().append(hs_generate_html_operators());
                woo_usn_field_values.empty().attr('name', 'customer-email').append('<input type="text" name="woo-usn[' + hash_code + '][cl-values]"  required/>');
                break;

            default:
                break;
        }
    };


    var woo_usn_reset_fields = function (hash_code) {
        hs_field_dynamic_views($("p[data-hash='" + hash_code + "'] select.woo-usn-cl-rules").val(), hash_code);
        $(document).on('change', 'p[data-hash="' + hash_code + '"] select.woo-usn-cl-rules', function (evt) {
            var option_name = $(this).val();
            hs_field_dynamic_views(option_name, hash_code);
           // hs_initiate_dynamic_select_fields( 'span.woo-usn-cl-values select[name="woo-usn['+hash_code+'][cl-values][]"]', 'span.woo-usn-cl-values select[name="woo-usn['+hash_code+'][cl-values][]"] option');
        });
    };

    $(document).on('click dbclick', '#woousn_add_custom_filters', function (e) {
        e.preventDefault();
        var hash_code = HSGenerateRandom(12);
        $('#woousn-custom-fields-block').append(hs_generate_fields(hash_code));
        woo_usn_reset_fields(hash_code);
    });

    $(document).on('click dbclick', 'button.woo-usn-cl-remove-block', function (e) {
        e.preventDefault();
        $(this).closest('p.woo-usn-cl-parent').remove();
        while ( $('p#woousn-custom-fields-block').is(':empty') ){
            $('#woousn_add_custom_filters').trigger('click');
            //hs_initiate_dynamic_select_fields( 'span.woo-usn-cl-values select', 'span.woo-usn-cl-values select option' );
        }
    });

    $(document).on('click dbclick', '#woousn_search', function (evt) {
        evt.preventDefault();
        var woo_usn_cl_obj = $('form').serializeJSON();
        var woo_usn_cl_list = woo_usn_cl_obj['woo-usn'];
        $('div.woousn-cl-loader').show();
        $('div.woousn-search-list').empty().hide();
        $.post(woo_usn_ajax_object.woo_usn_ajax_url, {
            action: 'get-customers-list',
            data: woo_usn_cl_list,
            'security': woo_usn_ajax_object.woo_usn_ajax_security
        }, function (response) {
            $('div.woousn-search-list').empty().show().append(response);
            $('div.woousn-cl-loader').hide();
        });
    });

    $(document).on('ready', function() {

        if ( typeof(woo_usn_cl_type) === 'undefined' ){
            return;
        }

        if (woo_usn_ajax_object.cl_list_data) {
            //if this code is executed, that means we are on customer list page.
            setTimeout(function () {
                $.blockUI({'message': woo_usn_ajax_object.cl_list_data.loader_message});
                if ( woo_usn_ajax_object.cl_list_data.length == 0 ){
                    $('#woousn_add_custom_filters').trigger('click');
                }else{
                    for (var hash in woo_usn_ajax_object.cl_list_data) {
                        hs_regenerate_html(hash, woo_usn_ajax_object.cl_list_data[hash]);
                    }        
                }
                $.unblockUI();
            }, 1000);
        } else {
            //if this code is executed, that means it's a new customer list.
            $('#woousn_add_custom_filters').trigger('click');
        }

        var usn_add_btn = $('input#woousn_add_custom_filters');
        if ( woo_usn_cl_type == "dynamic" ){
            $('tr.woo-usn-customer-list-dynamic').show();
            $('tr.woo-usn-customer-list-manual').hide();
            usn_add_btn.show();
        }else{
            $('tr.woo-usn-customer-list-dynamic').hide();
            $('tr.woo-usn-customer-list-manual').show();
            usn_add_btn.hide();
        }

        $(document).on('change click dbclick', 'input[name="woo-usn[customer-list-search-type]"]', function (){
            var usn_type = $(this).val();
            hs_hide_show_fields( usn_type );
        });

    });

})(jQuery);
