(function( $ ) {
	'use strict';

	/**
	 * All of the code for your public-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	 var iti;
	$(document).ready(function(){
		if ( woo_usn_ajax_object.woo_usn_phone_utils_path ){
			var woousn_phone_number_validator = document.querySelector("#billing_phone");  
			var country_code = 'us';
			if ( woo_usn_ajax_object.user_country_code ){
				country_code = woo_usn_ajax_object.user_country_code;
			}
			try{
				iti =  window.intlTelInput(woousn_phone_number_validator,{
					initialCountry: country_code,
					utilsScript : woo_usn_ajax_object.woo_usn_phone_utils_path
				});
				}  catch(e){
					console.info(e);
				}
		}
	});

})( jQuery );
