<?php
/**
 *
 * Plugin Name:       Ultimate SMS Notifications for WooCommerce
 * Plugin URI:        https://ultimatesmsnotifications.com
 * Description:       Send Bulk SMS and SMS Notifications from your WooCommerce store made-easy.
 * Version:           1.5.9
 * Author:            HomeScript
 * Author URI:        https://ultimatesmsnotifications.com?utm_source=customer_websites
 * License:           GPL-2.0+
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       ultimate-sms-notifications
 * Domain Path:       /languages
 * WC requires at least: 3.0.0
 * WC tested up to: 5.0
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) && ! defined( 'ABSPATH' ) ) {
	die;
}
require plugin_dir_path( __FILE__ ) . 'includes/abstract/constants.php';
require plugin_dir_path( __FILE__ ) . 'includes/require.php';


register_activation_hook( __FILE__, 'activate_woo_usn' );
/**
 * Code fired after activate the plugin.
 *
 * @return void
 */
function activate_woo_usn() {
	$options = get_option( 'woo_usn_options' );
	if ( ! isset( $options ) ) {
		update_option( 'woo_usn_options', array() );
	}
}

register_deactivation_hook( __FILE__, 'deactivate_woo_usn' );
/**
 * Code fired after deactivate the plugin.
 *
 * @return void
 */
function deactivate_woo_usn() {
	as_unschedule_all_actions( 'woo_usn_init_schedule_sms' );
	as_unschedule_all_actions( 'woo_usn_schedule_sms' );
}

/**
 * This function the core of the plugin.
 */
function run_woo_usn() {
	$plugin = new Woo_Usn();
	$plugin->run();
}
run_woo_usn();
